# Generated by Django 3.2.8 on 2024-02-13 21:01

from django.db import migrations, models
from django.db.models import Count

def count_cars(apps, schema_editor):
    OwnedCar = apps.get_model("car_collection", "OwnedCar")
    # SELECT model, COUNT(model) AS dcount FROM OwnedCar GROUP BY model
    # result is a dict I can iterate on
    result = OwnedCar.objects.values("model").annotate(dcount=Count("model")).order_by()
    print("result="+str(result))
    for ownedmodel in result.iterator():
        print("ownedmodel="+str(ownedmodel))
        count = 0
        for ownedcar in OwnedCar.objects.filter(model__id=ownedmodel["model"]).all():
            if count == 0:
                ownedcar.number = ownedmodel["dcount"]
                ownedcar.save()
            else:
                ownedcar.delete()
            count = count + 1


class Migration(migrations.Migration):

    dependencies = [
        ('car_collection', '0008_carmodel_price'),
    ]

    operations = [
        migrations.RemoveField(
            model_name='ownedcar',
            name='year',
        ),
        migrations.AddField(
            model_name='ownedcar',
            name='number',
            field=models.IntegerField(default=0),
        ),
        migrations.RunPython(count_cars),
    ]
